// CompilersDlg.cpp : implementation file
//

#include "stdafx.h"
#include "Visual Client.h"
#include "CompilersDlg.h"

using namespace std;

// CCompilersDlg dialog

IMPLEMENT_DYNAMIC(CCompilersDlg, CDialog)
CCompilersDlg::CCompilersDlg(CWnd* pParent,
							 const vector< CClientHandler::SCompiler >& compilers)
	: CDialog(CCompilersDlg::IDD, pParent)
	, m_compilers(compilers)
{
}

CCompilersDlg::~CCompilersDlg()
{
}

void CCompilersDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_LIST_COMPILERS, m_listBoxCompilers);
}


BEGIN_MESSAGE_MAP(CCompilersDlg, CDialog)
	ON_WM_SHOWWINDOW()
END_MESSAGE_MAP()


// CCompilersDlg message handlers

void CCompilersDlg::Updata()
{
	while(m_listBoxCompilers.GetCount())
		m_listBoxCompilers.DeleteString(0);
	vector< CClientHandler::SCompiler >::const_iterator i = m_compilers.begin();
	vector< CClientHandler::SCompiler >::const_iterator e = m_compilers.end();
	for(; i != e; ++i)
		m_listBoxCompilers.AddString(i->compilerName.c_str());
}

void CCompilersDlg::OnShowWindow(BOOL bShow, UINT nStatus)
{
	CDialog::OnShowWindow(bShow, nStatus);

	Updata();
	m_listBoxCompilers.SetFocus();
	if(m_listBoxCompilers.GetCount() > 0) 
		m_listBoxCompilers.SetCurSel(0);
}

void CCompilersDlg::OnOK()
{
	m_selPos = m_listBoxCompilers.GetCurSel();

	CDialog::OnOK();
}
