#ifndef GUARD_Ptr_h
#define GUARD_Ptr_h

template <class T> T* clone(T* pt) { return pt->clone(); }

template <class T> const T& my_max(const T& a, const T& b) { return a > b ? a : b; }

template <class T>
class CountedPtr
{
	class Impl
	{
		friend class CountedPtr<T>;

		size_t count_ref_;
		T* pt_;

		Impl(T* pt): pt_(pt), count_ref_(1) {}
		~Impl() { delete pt_; }
	public:
	};

	Impl* pImpl_;
public:
	explicit CountedPtr(T* pt): pImpl_(new Impl(pt)) {}
	CountedPtr& operator =(T* pt) {
		Dec();
		pImpl_ = new Impl(pt);
		return *this;
	}
	~CountedPtr() { Dec(); }
	CountedPtr(const CountedPtr& other): pImpl_(other.pImpl_) { Inc(); }
	CountedPtr& operator =(const CountedPtr& other) {
		if(&other != this) {
			Dec();
			pImpl_ = other.pImpl_;
			Inc();
		}
		return *this;
	}

	void make_unique() {
		if(pImpl_->count_ref_ != 1) {
			Dec();
			pImpl_ = (pImpl_->pt_ ? new Impl(clone(pImpl_->pt_)) : NULL);
		}
	}

	T* operator ->() { return pImpl_->pt_; }
	const T* operator ->() const { return pImpl_->pt_; }
	T& operator *() { return *(pImpl_->pt_); }
	const T& operator *() const { return *(pImpl_->pt_); }
	operator bool() const { return pImpl_->pt_ ? true : false; }
private:
	void Dec() {
		if(--(pImpl_->count_ref_) == 0) {
			delete pImpl_;
		}
	}
	void Inc() { ++(pImpl_->count_ref_); }
};

#endif
