// SendDlg.cpp : implementation file
//

#include "stdafx.h"
#include "Visual Client.h"
#include "SendDlg.h"

#include "TasksDlg.h"
#include "CompilersDlg.h"

using namespace std;

// CSendDlg dialog

IMPLEMENT_DYNAMIC(CSendDlg, CDialog)
CSendDlg::CSendDlg(CWnd* pParent, 
		const vector< CClientHandler::STask >& tasks,
		const vector< CClientHandler::SCompiler >& compilers)
	: CDialog(CSendDlg::IDD, pParent)
	, m_tasks(tasks)
	, m_compilers(compilers)
	, m_nTask(-1)
	, m_nCompiler(-1)
{
}

CSendDlg::~CSendDlg()
{
}

void CSendDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}


BEGIN_MESSAGE_MAP(CSendDlg, CDialog)
	ON_BN_CLICKED(IDC_BUTTON_SELECT_TASK, OnBnClickedButtonSelectTask)
	ON_BN_CLICKED(IDC_BUTTON_SELECT_COMPILER, OnBnClickedButtonSelectCompiler)
END_MESSAGE_MAP()


// CSendDlg message handlers

void CSendDlg::OnBnClickedButtonSelectTask()
{
	CTasksDlg dlg(this, m_tasks);
	if(dlg.DoModal() == IDOK) {
		m_nTask = dlg.m_selPos;
		if(m_nTask != -1) {
			SetDlgItemText(IDC_EDIT_TASK, (m_tasks[m_nTask].taskNumber + ": " + m_tasks[m_nTask].taskName).c_str());
		}
	}
}

void CSendDlg::OnBnClickedButtonSelectCompiler()
{
	CCompilersDlg dlg(this, m_compilers);
	if(dlg.DoModal() == IDOK) {
		m_nCompiler = dlg.m_selPos;
		if(m_nCompiler != -1) {
			SetDlgItemText(IDC_EDIT_COMPILER, m_compilers[m_nCompiler].compilerName.c_str());
		}
	}
}

void CSendDlg::OnOK()
{
	if(m_nTask == -1) {
		MessageBox("You didn't select a task");
		return;
	}
	if(m_nCompiler == -1) {
		MessageBox("You didn't select a compiler");
		return;
	}
	CDialog::OnOK();
}
