// TasksDlg.cpp : implementation file
//

#include "stdafx.h"
#include "Visual Client.h"
#include "TasksDlg.h"


// CTasksDlg dialog

IMPLEMENT_DYNAMIC(CTasksDlg, CDialog)
CTasksDlg::CTasksDlg(CWnd* pParent,
					 const std::vector< CClientHandler::STask >& tasks)
	: CDialog(CTasksDlg::IDD, pParent)
	, m_tasks(tasks)
	, m_strTaskDesc(_T(""))
{
}

CTasksDlg::~CTasksDlg()
{
}

void CTasksDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Text(pDX, IDC_EDIT_TASK_DESC, m_strTaskDesc);
	DDX_Control(pDX, IDC_LIST_TASKS, m_listBoxTasks);
}


BEGIN_MESSAGE_MAP(CTasksDlg, CDialog)
	ON_LBN_SELCHANGE(IDC_LIST_TASKS, OnLbnSelchangeListTasks)
	ON_BN_CLICKED(IDOK, OnBnClickedOk)
	ON_WM_SHOWWINDOW()
END_MESSAGE_MAP()

void CTasksDlg::Updata()
{
	while(m_listBoxTasks.GetCount())
		m_listBoxTasks.DeleteString(0);
	std::vector< CClientHandler::STask >::const_iterator i = m_tasks.begin();
	std::vector< CClientHandler::STask >::const_iterator e = m_tasks.end();
	for(; i != e; ++i)
		m_listBoxTasks.AddString((i->taskNumber + ": " + i->taskName).c_str());
}

// CTasksDlg message handlers

void CTasksDlg::OnLbnSelchangeListTasks()
{/*
	int pos = m_listBoxTasks.GetCurSel();
	CString text;
	if(pos != -1)
		text = m_tasks[pos].taskName.c_str();
	SetDlgItemText(IDC_EDIT_TASK_DESC, text);*/
}

void CTasksDlg::OnBnClickedOk()
{
	m_selPos = m_listBoxTasks.GetCurSel();
	OnOK();
}

void CTasksDlg::OnShowWindow(BOOL bShow, UINT nStatus)
{
	CDialog::OnShowWindow(bShow, nStatus);

	Updata();
	m_listBoxTasks.SetFocus();
	if(m_listBoxTasks.GetCount() > 0) 
		m_listBoxTasks.SetCurSel(0);
}
